BinaryExpression (Groovy 3.0.9)

Package org.codehaus.groovy.ast.expr

## Class BinaryExpression

- java.lang.Object
- - org.codehaus.groovy.ast.ASTNode
  - - org.codehaus.groovy.ast.AnnotatedNode
    - - org.codehaus.groovy.ast.expr.Expression
      - - org.codehaus.groovy.ast.expr.BinaryExpression

- All Implemented Interfaces:
    `GroovydocHolder<AnnotatedNode>`, `NodeMetaDataHandler`
  Direct Known Subclasses:
    `CompareIdentityExpression`, `CompareToNullExpression`, `DeclarationExpression`

      public class BinaryExpression
      extends Expression

  Represents two expressions and an operation

- - ### Field Summary

    - ### Fields inherited from class org.codehaus.groovy.ast.expr.Expression

      `EMPTY_ARRAY`

    - ### Fields inherited from interface groovy.lang.groovydoc.GroovydocHolder

      `DOC_COMMENT`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `BinaryExpression​(Expression leftExpression, Token operation, Expression rightExpression)` |
    `BinaryExpression​(Expression leftExpression, Token operation, Expression rightExpression, boolean safe)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Expression` | `getLeftExpression()` |
    `Token` | `getOperation()` |
    `Expression` | `getRightExpression()` |
    `String` | `getText()` |
    `boolean` | `isSafe()` |
    `static BinaryExpression` | `newAssignmentExpression​(Variable variable, Expression rhs)` | Creates an assignment expression in which the specified expression is written into the specified variable name.
    `static BinaryExpression` | `newInitializationExpression​(String variable, ClassNode type, Expression rhs)` | Creates variable initialization expression in which the specified expression is written into the specified variable name.
    `void` | `setLeftExpression​(Expression leftExpression)` |
    `void` | `setRightExpression​(Expression rightExpression)` |
    `void` | `setSafe​(boolean safe)` |
    `String` | `toString()` |
    `Expression` | `transformExpression​(ExpressionTransformer transformer)` | Return a copy of the expression calling the transformer on any nested expressions
    `void` | `visit​(GroovyCodeVisitor visitor)` |

    - ### Methods inherited from class org.codehaus.groovy.ast.expr.Expression

      `getType, setType, transformExpressions, transformExpressions`

    - ### Methods inherited from class org.codehaus.groovy.ast.AnnotatedNode

      `addAnnotation, addAnnotations, getAnnotations, getAnnotations, getDeclaringClass, getGroovydoc, getInstance, hasNoRealSourcePosition, isSynthetic, setDeclaringClass, setHasNoRealSourcePosition, setSynthetic`

    - ### Methods inherited from class org.codehaus.groovy.ast.ASTNode

      `copyNodeMetaData, getColumnNumber, getLastColumnNumber, getLastLineNumber, getLineNumber, getMetaDataMap, setColumnNumber, setLastColumnNumber, setLastLineNumber, setLineNumber, setMetaDataMap, setSourcePosition`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.codehaus.groovy.ast.NodeMetaDataHandler

      `copyNodeMetaData, getNodeMetaData, getNodeMetaData, getNodeMetaData, putNodeMetaData, removeNodeMetaData, setNodeMetaData`

- - ### Constructor Detail

    - #### BinaryExpression

          public BinaryExpression​(Expression leftExpression,
                                  Token operation,
                                  Expression rightExpression)

    - #### BinaryExpression

          public BinaryExpression​(Expression leftExpression,
                                  Token operation,
                                  Expression rightExpression,
                                  boolean safe)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### visit

          public void visit​(GroovyCodeVisitor visitor)

      Overrides:
        `visit` in class `ASTNode`

    - #### transformExpression

          public Expression transformExpression​(ExpressionTransformer transformer)

      Description copied from class: `Expression`
      Return a copy of the expression calling the transformer on any nested expressions
      Specified by:
        `transformExpression` in class `Expression`

    - #### getLeftExpression

          public Expression getLeftExpression()

    - #### setLeftExpression

          public void setLeftExpression​(Expression leftExpression)

    - #### setRightExpression

          public void setRightExpression​(Expression rightExpression)

    - #### getOperation

          public Token getOperation()

    - #### getRightExpression

          public Expression getRightExpression()

    - #### getText

          public String getText()

      Overrides:
        `getText` in class `ASTNode`

    - #### isSafe

          public boolean isSafe()

    - #### setSafe

          public void setSafe​(boolean safe)

    - #### newAssignmentExpression

          public static BinaryExpression newAssignmentExpression​(Variable variable,
                                                                 Expression rhs)

      Creates an assignment expression in which the specified expression is written into the specified variable name.

    - #### newInitializationExpression

          public static BinaryExpression newInitializationExpression​(String variable,
                                                                     ClassNode type,
                                                                     Expression rhs)

      Creates variable initialization expression in which the specified expression is written into the specified variable name.